Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class FloatValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.NumericValue
                  net.sf.saxon.value.FloatValue

All Implemented Interfaces:
  java.lang.Comparable, Expression, Item, java.io.Serializable, ValueRepresentation

public final class FloatValue
extends NumericValue

A numeric (single precision floating point) value

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`FloatValue(java.lang.CharSequence val)` Constructor supplying a string
`FloatValue(float value)` Constructor supplying a float

Method Summary
`NumericValue` | `arithmetic(int operator, NumericValue other, XPathContext context)` Evaluate a binary arithmetic operator.
`NumericValue` | `ceiling()` Implement the XPath ceiling() function
`int` | `compareTo(java.lang.Object other)` Compare the value to another numeric value
`AtomicValue` | `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`java.lang.Object` | `convertToJava(java.lang.Class target, XPathContext context)` Convert to Java object (for passing to external functions)
`boolean` | `effectiveBooleanValue(XPathContext context)` Get the effective boolean value
`NumericValue` | `floor()` Implement the XPath floor() function
`double` | `getDoubleValue()` Get the numeric value as a double
`float` | `getFloatValue()` Get the value
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the expression
`java.lang.String` | `getStringValue()` Get the value as a String
`java.lang.CharSequence` | `getStringValueCS()` Get the value as a String
`int` | `hashCode()` Get the hashCode.
`boolean` | `isNaN()` Test whether the value is the double/float value NaN
`boolean` | `isWholeNumber()` Determine whether the value is a whole number, that is, whether it compares equal to some integer
`NumericValue` | `negate()` Negate the value
`NumericValue` | `round()` Implement the XPath round() function
`NumericValue` | `roundToHalfEven(int scale)` Implement the XPath round-to-half-even() function
`boolean` | `schemaEquals(Value obj)` Compare two values for equality.
`double` | `signum()` Determine whether the value is negative, zero, or positive

Methods inherited from class net.sf.saxon.value.NumericValue
`equals, isInteger, longValue, parseNumber, promote, toString`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, display, evaluateAsString, evaluateItem, getCardinality, getComponent, getImplementationMethod, getLength, getPrimitiveValue, getTypedValue, hasBuiltInType, iterate, process`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asIterator, asValue, collapseWhitespace, convert, convertJavaObjectToXPath, getDependencies, getIterator, getParentExpression, getSpecialProperties, itemAt, iterateSubExpressions, makeQNameValue, normalizeWhitespace, optimize, promote, reduce, simplify, stringToNumber, trimWhitespace, typeCheck`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FloatValue

    public FloatValue(java.lang.CharSequence val)
               throws DynamicError

  Constructor supplying a string

### FloatValue

    public FloatValue(float value)

  Constructor supplying a float

Parameters:
  `value` - the value of the float

Method Detail

### getFloatValue

    public float getFloatValue()

  Get the value

### getDoubleValue

    public double getDoubleValue()

  Description copied from class: `NumericValue`
  Get the numeric value as a double

  Overrides:
    `getDoubleValue` in class `NumericValue`
  Returns:
    A double representing this numeric value; NaN if it cannot be converted

### hashCode

    public int hashCode()

  Get the hashCode. This must conform to the rules for other NumericValue hashcodes

  Specified by:
    `hashCode` in class `NumericValue`
  Returns:
    the hash code of the numeric value
  See Also:
    `NumericValue.hashCode()`

### isNaN

    public boolean isNaN()

  Test whether the value is the double/float value NaN

  Overrides:
    `isNaN` in class `NumericValue`

### effectiveBooleanValue

    public boolean effectiveBooleanValue(XPathContext context)

  Get the effective boolean value

  Specified by:
    `effectiveBooleanValue` in interface `Expression`
  Overrides:
    `effectiveBooleanValue` in class `AtomicValue`
  Parameters:
    `context` -
  Returns:
    true unless the value is zero or NaN

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate,
                                        XPathContext context)

  Convert to target data type

  Specified by:
    `convertPrimitive` in class `AtomicValue`
  Parameters:
    `requiredType` - an integer identifying the required atomic type
    `context` -
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    an AtomicValue, a value of the required type; or an ErrorValue

### getStringValue

    public java.lang.String getStringValue()

  Get the value as a String

  Specified by:
    `getStringValue` in interface `Item`
  Specified by:
    `getStringValue` in class `AtomicValue`
  Returns:
    a String representation of the value

### getStringValueCS

    public java.lang.CharSequence getStringValueCS()

  Get the value as a String

  Specified by:
    `getStringValueCS` in interface `Item`
  Overrides:
    `getStringValueCS` in class `AtomicValue`
  Returns:
    a String representation of the value

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the expression

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `Value`
  Parameters:
    `th` -
  Returns:
    Type.DOUBLE

### negate

    public NumericValue negate()

  Negate the value

  Specified by:
    `negate` in class `NumericValue`
  Returns:
    a value, of the same type as the original, with its sign inverted

### floor

    public NumericValue floor()

  Implement the XPath floor() function

  Specified by:
    `floor` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards minus infinity

### ceiling

    public NumericValue ceiling()

  Implement the XPath ceiling() function

  Specified by:
    `ceiling` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards plus infinity

### round

    public NumericValue round()

  Implement the XPath round() function

  Specified by:
    `round` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards the nearest whole number (0.5 rounded up)

### roundToHalfEven

    public NumericValue roundToHalfEven(int scale)

  Implement the XPath round-to-half-even() function

  Specified by:
    `roundToHalfEven` in class `NumericValue`
  Parameters:
    `scale` - the decimal position for rounding: e.g. 2 rounds to a multiple of 0.01, while -2 rounds to a multiple of 100
  Returns:
    a value, of the same type as the original, rounded towards the nearest multiple of 10**(-scale), with rounding towards the nearest even number if two values are equally near

### signum

    public double signum()

  Determine whether the value is negative, zero, or positive

  Specified by:
    `signum` in class `NumericValue`
  Returns:
    -1 if negative, 0 if zero (including negative zero), +1 if positive, NaN if NaN

### isWholeNumber

    public boolean isWholeNumber()

  Determine whether the value is a whole number, that is, whether it compares equal to some integer

  Specified by:
    `isWholeNumber` in class `NumericValue`
  Returns:
    true if the value is a whole number

### arithmetic

    public NumericValue arithmetic(int operator,
                                   NumericValue other,
                                   XPathContext context)
                            throws XPathException

  Evaluate a binary arithmetic operator.

  Specified by:
    `arithmetic` in class `NumericValue`
  Parameters:
    `operator` - the binary arithmetic operation to be performed. Uses the constants defined in the Tokenizer class
    `other` - the other operand
  Returns:
    the result of the arithmetic operation
  Throws:
    `XPathException` - if an arithmetic error occurs
  See Also:
    `Tokenizer`

### compareTo

    public int compareTo(java.lang.Object other)

  Description copied from class: `NumericValue`
  Compare the value to another numeric value

  Specified by:
    `compareTo` in interface `java.lang.Comparable`
  Overrides:
    `compareTo` in class `NumericValue`
  Parameters:
    `other` - The other numeric value
  Returns:
    -1 if this one is the lower, 0 if they are numerically equal, +1 if this one is the higher.

### schemaEquals

    public boolean schemaEquals(Value obj)

  Compare two values for equality. This supports identity constraints in XML Schema, which allow list-valued elements and attributes to participate in key and uniqueness constraints. This method returns false if any error occurs during the comparison, or if any of the items in either sequence is a node rather than an atomic value. The default implementation of schemaEquals() is the same as equals(), but subclasses can override this.

  Overrides:
    `schemaEquals` in class `AtomicValue`

### convertToJava

    public java.lang.Object convertToJava(java.lang.Class target,
                                          XPathContext context)
                                   throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `Value`
  Throws:
    `XPathException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD